package com.api.hrm.util;

import com.engine.common.service.HrmCommonService;
import com.engine.common.service.impl.HrmCommonServiceImpl;
import com.engine.hrm.biz.HrmSanyuanAdminBiz;
import org.apache.commons.lang.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.appdetach.AppDetachComInfo;
import weaver.hrm.moduledetach.ManageDetachComInfo;
import weaver.hrm.resource.ResourceComInfo;

import java.util.StringJoiner;

public class HrmReportDetachUtil extends BaseBean {

    private char flag = Util.getSeparator();

    private String rightStr = "HrmResourceAdd:Add";



    public String getDetachSqlWhere(int userId, String alias){
        String sqlWhere = "";
        String manageDetachSqlWhere = this.getManageDetachSqlWhere(userId, alias);
        String appDetachSqlWhere = "";
        AppDetachComInfo appDetachComInfo = new AppDetachComInfo();
        try {
            appDetachSqlWhere = appDetachComInfo.getScopeSqlByHrmResourceSearch("" + userId, true, "resource_" + alias);
        } catch (Exception e){
            writeLog("获取应用分权SQL片段异常");
            writeLog(e);
        }

        if (StringUtils.isNotBlank(manageDetachSqlWhere) && StringUtils.isNotBlank(appDetachSqlWhere)){
            sqlWhere = manageDetachSqlWhere + " and " + appDetachSqlWhere;
        } else if (StringUtils.isNotBlank(manageDetachSqlWhere) && StringUtils.isBlank(appDetachSqlWhere)){
            sqlWhere = manageDetachSqlWhere;
        } else if (StringUtils.isBlank(manageDetachSqlWhere) && StringUtils.isNotBlank(appDetachSqlWhere)){
            sqlWhere = appDetachSqlWhere;
        }

        writeLog("分权sqlwhere：" + sqlWhere);

        return sqlWhere;
    }

    private String getManageDetachSqlWhere(int userId, String alias){
        String sqlWhere = "";

        try {
            ManageDetachComInfo manageDetachComInfo = new ManageDetachComInfo();
            ResourceComInfo resourceComInfo = new ResourceComInfo();
            RecordSet recordSet = new RecordSet();


            // 是否开启了管理分权
            if (manageDetachComInfo.isUseManageDetach()){
                // 是否启用了人力资源管理分权
                if (manageDetachComInfo.isUseHrmManageDetach()){
                    // 系统管理员和大三员可以看所有机构
                    boolean canView = HrmSanyuanAdminBiz.canViewAllSubCompany(userId);
                    if (userId == 1 || canView){
                        return sqlWhere;
                    }
                    StringJoiner stringJoiner = new StringJoiner(",");
                    writeLog("启用人力资源管理分权");
                    recordSet.executeProc("HrmRoleSR_SeByURId", "" + userId + flag + rightStr);
                    while (recordSet.next()) {
                        if (recordSet.getInt("rightlevel") > -1) {
                            stringJoiner.add(String.valueOf(recordSet.getInt("subcompanyid")));
                        } else if (recordSet.getInt("rightlevel") == -1) {
                            stringJoiner.add(String.valueOf(-1 * recordSet.getInt("subcompanyid")));
                        }
                    }
                    String subCompanyIds = stringJoiner.toString();
                    if (subCompanyIds.length() == 0){
                        // 没有机构权限，查看不了任何分部
                        sqlWhere = " 1= 2";
                    } else {
                        sqlWhere = alias + ".subcompanyid1 in (" + subCompanyIds + ")";
                    }
                } else {
                    writeLog("未启用人力资源管理分权");
                    if (resourceComInfo.isAdmin("" + userId)){
                        return sqlWhere;
                    }
                    HrmCommonService hrmCommonService = new HrmCommonServiceImpl();
                    int roleLevel = hrmCommonService.getMaxRoleLevel(userId, rightStr);
                    if (roleLevel < 0){
                        sqlWhere = " 1=2 ";
                    } else if (roleLevel == 0){
                        // 成员级别为部门
                        String departmentId = resourceComInfo.getDepartmentID("" + userId);
                        sqlWhere = alias + ".departmentid = " + departmentId;
                    } else if (roleLevel == 1){
                        // 成员级别为分部
                        String subCompanyId = resourceComInfo.getSubCompanyID("" + userId);
                        sqlWhere = alias + ".subcompanyid1 = " + subCompanyId;
                    }
                }
            }
        } catch (Exception e){
            writeLog("获取管理分权SQL片段异常");
            writeLog(e);
        }
        return sqlWhere;
    }

}
