package com.engine.gainway.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.gainway.service.BasicResourceTableService;
import com.engine.gainway.service.impl.BasicResourceTableServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/12/11 2:25 PM
 * @Description: TODO
 * @Version 1.0
 */
public class BasicResourceTableAction {

    private BasicResourceTableService getService(User user) {
        return  ServiceUtil.getService(BasicResourceTableServiceImpl.class, user);
    }

    @GET
    @Path("/linkTable")
    @Produces(MediaType.TEXT_PLAIN)
    public String linkTable(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("datas",getService(user).linkTable(ParamUtil.request2Map(request)));
            data.put("api_status", true);
        } catch (Exception e) {
            data.put("api_status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

}
